
  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000       '80 MHz
VAR
  long  stack[200], frame[400], key, id
  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight
  long  col, row, color, tilex, tiley, colU, rowU, ms
  long  boxcolor,ptr  ', errorT1
'vars for Graphics Demo
  long  mousex, mousey   
  long  touchx, touchy
'  long touchx0,touchdx,touchy0,touchdy   'cal factors
  long  CurrentColor, bLineMode, bStillDown, LastX, LastY
'  word  screen[screensize]
'for custom characters
  word  user_charbase  
  byte  Trk1buffer[85], Trk2buffer[45], colorA, colorB, flagReg, Char, Indexx 
'  byte  x[lines], y[lines], xs[lines], ys[lines]           ' FlagReg: lsb = 'cap'key ON; 

OBJ
'  lcd  : "PSB_LcdDriver"  'Modified to drive 4.3" TFT
'  i2c  : "PSB_i2cDriver"        ' Rokicki & Dummer's i2c
'  gr   : "graphics"             ' Chip Gracey's object
' kbd  : "Keyboard"             ' Ps/2 keyboard
'  mouse : "mouse"
'  fsrw : "fsrw" '
'  sd2 : "SD2.0_FATEngine"  'Kye's SD card engine
  vp    : "Conduit"                  ' transfers data to/from PC, 1 cog
  qs    : "QuickSample"              ' captures INA, variables, 1 cog @20 MHz
'  dbg   : "PasDebug"            'PASD debugger; needs a .dbg file

PUB Main                        ' Start up Display 
  vp.register(qs.sampleINA(@frame,1)) 'sample INA w/ 1 cog up to 20 MHz (MUST BE COG 0)
  optional_configure_viewport   ' optionally configure Viewport's interface                                                                                                                                                                                                                                                                                                                                                                                                                                                     
  vp.share(@key,@id) 'share memory from 'key' to 'id';   END of VP commands <<===  
   
'  print($100)                   ' show black on silver
'start graphic  and i2c drivers
  lcd_enable:=1
'  lcd_videobase := @screen
'  lcd_colorbase := @vgacolors
  lcd_backlight:= 22  '1=bright, 16=medium, 32=dark
'  lcd.start(@lcd_status)

'  i2c.initialize                'init touch controller                  ' TSC2003 touch IC
'  Trk1buffer := Trk1base
  Trk2buffer := Trk1buffer + 80
'  repeat 20     
'    i2c.GetTouchX
'  id := cognew(@Track1,@Trk1buffer)
'  id := cognew(@entry,@Trk1buffer)
'  id := cognew(@Track2,@Trk2buffer)
'  id := cognew(@entry,@Trk2buffer)
'  id := dbg.start(31,30,@entry) ' <===  include for PASD debugger  <===
'  GraphicsDemo
'+-------------------------------------------------------------------------------------+
PUB optional_configure_viewport                                                                                                
  vp.config(string("var:io(bits=[all[0..29],30tx,31rx])"))
  vp.config(string("var:io,key,id")) ' show these VARs
  vp.config(string("lsa:view=io,timescale=200ns,trigger=io[8]f")) ' trig on A8 falling
  vp.config(string("edit:key(default=5,mode=text)"))
  vp.config(string("start:lsa"))                 
'+-------------------------------------------------------------------------------------+